#include <SDL/SDL.h>
#include <SDL_gfxPrimitives_font.h>
#include <SDL_gfxPrimitives.h>
#include <SDL_framerate.h>
#include <SDL_imageFilter.h>
#include <SDL_rotozoom.h>

#include <stdlib.h>

#define RESX 640
#define RESY 480
#define BITDEPTH 16

int main (int argc, char** argv)
{
	SDL_Surface * pantalla;
	
	if (SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		fprintf(stderr,"Error en la inicializacion de SDL: %s\n",SDL_GetError());
		exit(1);
	}
	
	if ( (pantalla = SDL_SetVideoMode(RESX, RESY, BITDEPTH, SDL_HWSURFACE)) == NULL)
	{
		fprintf(stderr,"Error SDL_SetVideoMode: %s\n",SDL_GetError());
		exit(1);
	}
		
	lineRGBA(pantalla, 0, 0, 100, 240, 0xFF, 0x00, 0x43, 0xFF);
	aalineRGBA(pantalla, 0, 20, 100, 260, 0xFF, 0x00, 0x43, 0xFF);
	boxRGBA(pantalla, 0, 200, 200, 380, 0xFF, 0xFF, 0xFF, 0x88);
	
	circleRGBA(pantalla, 300, 100, 50, 0x11, 0x00, 0xFF, 0xff);
	filledCircleRGBA(pantalla, 403, 100, 50, 0xFA, 0x33, 0xFF, 0xff);
	
	stringRGBA(pantalla, 300,400, "[Raist]DJ Sound of Music" ,0x33,0xFF,0xFF,0xFF);
	
	
	
	SDL_UpdateRect(pantalla,0,0,0,0);
	
	SDL_Delay(5000);
	
	
	SDL_Surface * imagen = SDL_LoadBMP("ghost.bmp");
	SDL_Surface * dest;
	double zoom = 0.0;
	bool aumentando = true;
	SDL_Rect  src,dst;
	src.x = 0;
	src.y = 0;
	dst.x = 300;
	dst.y = 250;
	
	for (double angulo=0.0; angulo<720.0 ; angulo+=3.0)
	{
		if (aumentando)
			zoom+=0.2;
		else
			zoom-=0.2;
		
		if (zoom > 3.0)
		{
			zoom = 3.0;
			aumentando = false;
		}
		else if (zoom <= 0.0)
		{
			zoom = 0.0;
			aumentando = true;
		}
		
		dest = rotozoomSurface(imagen, angulo, zoom, 1);
		src.w = dest->w;
		src.h = dest->h;
		dst.x = 300 - (dest->w/2);
		dst.y = 240 - (dest->h/2);
		SDL_BlitSurface(dest, &src, pantalla, &dst);
		printf("Pintado Txipi\n");
		SDL_UpdateRect(pantalla,0,0,0,0);
		printf("Updateada pantalla\n");
		SDL_FreeSurface(dest);
		SDL_FillRect(pantalla,NULL,0x00000000); 
		SDL_Delay(20);
		
	}
	
	
	
	atexit(SDL_Quit);
}
